"use strict";
exports.__esModule = true;
exports.nextStep = void 0;
var indexOfMax_1 = require("./indexOfMax");
var indexOfMin_1 = require("./indexOfMin");
var penaltyOfMatrix_1 = require("./penaltyOfMatrix");
var nextStep = function (problem, step) {
    step = JSON.parse(JSON.stringify(step));
    step.penalty = (0, penaltyOfMatrix_1.penaltyOfMatrix)(problem.matrix, step.strike);
    var xmax = (0, indexOfMax_1.indexOfMax)(step.penalty.x, step.strike.x);
    var ymax = (0, indexOfMax_1.indexOfMax)(step.penalty.y, step.strike.y);
    if (step.penalty.x[xmax] > step.penalty.y[ymax]) {
        var ys = [];
        for (var y = 0; y < step.matrix.length; y++) {
            var cost = problem.matrix[y][xmax];
            ys.push(cost);
        }
        var ymin = (0, indexOfMin_1.indexOfMin)(ys, step.strike.y);
        var min = Math.min(step.y[ymin], step.x[xmax]);
        step.matrix[ymin][xmax] = min;
        step.y[ymin] -= min;
        step.x[xmax] -= min;
        if (step.y[ymin] === 0) {
            step.strike.y.push(ymin);
        }
        if (step.x[xmax] === 0) {
            step.strike.x.push(xmax);
        }
        step.calculation1 += " + (".concat(step.matrix[ymin][xmax], " x ").concat(problem.matrix[ymin][xmax], ")");
        var calculation = step.matrix[ymin][xmax] * problem.matrix[ymin][xmax];
        step.calculation2 += " + " + calculation;
        step.total += calculation;
    }
    else {
        var xmin = (0, indexOfMin_1.indexOfMin)(problem.matrix[ymax], step.strike.x);
        var min = Math.min(step.y[ymax], step.x[xmin]);
        step.matrix[ymax][xmin] = min;
        step.y[ymax] -= min;
        step.x[xmin] -= min;
        if (step.y[ymax] === 0) {
            step.strike.y.push(ymax);
        }
        if (step.x[xmin] === 0) {
            step.strike.x.push(xmin);
        }
        step.calculation1 += " + (".concat(step.matrix[ymax][xmin], " x ").concat(problem.matrix[ymax][xmin], ")");
        var calculation = step.matrix[ymax][xmin] * problem.matrix[ymax][xmin];
        step.calculation2 += " + " + calculation;
        step.total += calculation;
    }
    return step;
};
exports.nextStep = nextStep;
