"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.penaltyOfMatrix = void 0;
var indexOfMin_1 = require("./indexOfMin");
var penaltyOfMatrix = function (matrix, except) {
    var penalty = {
        x: [],
        y: []
    };
    for (var y = 0; y < matrix.length; y++) {
        if (except && except.y.indexOf(y) !== -1) {
            penalty.y.push(0);
            continue;
        }
        var xs = matrix[y];
        var min = (0, indexOfMin_1.indexOfMin)(xs, except.x);
        var secondMin = (0, indexOfMin_1.indexOfMin)(xs, __spreadArray([min], except.x, true));
        var difference = 0;
        if (secondMin !== -1 && min !== -1) {
            difference = xs[secondMin] - xs[min];
        }
        else if (secondMin !== -1) {
            difference = xs[secondMin];
        }
        else if (min !== -1) {
            difference = xs[min];
        }
        penalty.y.push(difference);
    }
    for (var x = 0; x < matrix[0].length; x++) {
        if (except && except.x.indexOf(x) !== -1) {
            penalty.x.push(0);
            continue;
        }
        var ys = [];
        for (var y = 0; y < matrix.length; y++) {
            var cost = matrix[y][x];
            ys.push(cost);
        }
        var min = (0, indexOfMin_1.indexOfMin)(ys, except.y);
        var secondMin = (0, indexOfMin_1.indexOfMin)(ys, __spreadArray([min], except.y, true));
        var difference = 0;
        if (secondMin !== -1 && min !== -1) {
            difference = ys[secondMin] - ys[min];
        }
        else if (secondMin !== -1) {
            difference = ys[secondMin];
        }
        else if (min !== -1) {
            difference = ys[min];
        }
        penalty.x.push(difference);
    }
    return penalty;
};
exports.penaltyOfMatrix = penaltyOfMatrix;
